using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Mythos._3_Vistas.Controladoras;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;
using System.Linq;
using Exferia_Formularios;
using Exferia_Mythos._0_Modelos;

namespace Exferia_Mythos._3_Vistas
{
    public partial class P_Tecnico : Exferia_Formularios.P_Base_Mantenimientos
    {

        #region Variables General
        private P_Tecnico_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        private System.Windows.Forms.Timer g_timer_Filtrar_Agrupaciones = new System.Windows.Forms.Timer();

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();

        #endregion

        #region Objetos en Pantalla

        //Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_Alta { get { return ex_usc_P_Tecnico_FechaAlta; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_Baja { get { return ex_usc_P_Tecnico_FechaBaja; } }

        //Exferia_F3
        internal Exferia_F3 Exferia_F3_Empleado { get { return ex_usc_F3_P_Tecnico_Empleado; } }

        //Exferia_F3_SoloSeleccion
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Terminal { get { return ex_usc_F3_P_Tecnico_Terminal; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_Codigo { get { return ex_lbl_P_Tecnico_Codigo; } }
        internal Exferia_Label Exferia_Label_Nombre { get { return ex_lbl_P_Tecnico_Nombre; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_Tecnico { get { return ex_Paginador; } }

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Codigo { get { return ex_txt_P_Tecnico_Codigo; } }
        internal Exferia_TextBox Exferia_TextBox_Nombre { get { return ex_txt_P_Tecnico_Nombre; } }

        //Exferia_TextBox_Email
        internal Exferia_TextBox_Email Exferia_TextBox_Email_EmailDocumentos { get { return ex_usc_P_Tecnico_EmaiDocumentos; } }

        #endregion

        #region Constructor
        public P_Tecnico(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_Tecnico_Controladora(this);

                //Datos de Opciones Detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
                ex_btn_P_Tecnico_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_Tecnico_Grabar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                //Tipo de campo Codigo, poner como numérico o texto ...............................
                if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO != null)
                {
                    //Si no existe es Text
                    if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO.Where(m => m.nombreCampoCodigo.Equals(nameof(MYT_Tecnicos.codigo)) && m.opcion.Equals(g_mdl_PRV_OpcionesDetalle.opcion)).FirstOrDefault() != null)
                    {
                        ex_txt_P_Tecnico_Codigo.Exferia_TextBox_Tipos = G_ENUM_TEXTBOX_TIPODATO.Digitos;
                        ex_txt_P_Tecnico_Codigo.Exferia_TextBox_Tipo_Decimal_Enteros = ex_txt_P_Tecnico_Codigo.Exferia_TextBox_MaxLength;

                        g_obj_Controladora.g_bol_CampoCodigo_Numerico = true;
                    }
                }
                //................................................................................

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Tecnico) + "/" + nameof(P_Tecnico));
                    }
                }
                //....................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                //Rellenar para los F3 .......................................
                //EMPLEADO 
                ex_usc_F3_P_Tecnico_Empleado.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_EMPLEADO;
                ex_usc_F3_P_Tecnico_Empleado.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_Tecnico_Empleado.Exferia_F3_PRINCIPAL_Obligatorio = true;

                //TERMINAL 
                ex_usc_F3_P_Tecnico_Terminal.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_GEN_TERMINALES;
                ex_usc_F3_P_Tecnico_Terminal.Exferia_F3_SoloSeleccion_PantallaContenedora = this;

                g_obj_Funciones_Paginador = new Funciones_Paginador();
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Tecnico) + "/" + nameof(P_Tecnico));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_Tecnico_Load(object sender, EventArgs e)
        {
            try
            {

                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }

                };
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Tecnico) + "/" + nameof(P_Tecnico_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }
        private void P_Tecnico_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {

                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        ActivarBotones(false);

                        //Se cambia el valor de la variable para no salte el evento de se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;
                        Exferia_FechaSeleccion_Alta.Exferia_FechaSeleccion_Fecha = Variables.G_DTT_FECHA_INICIAL_PORDEFECTO.ToString("dd/MM/yyyy");

                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                Exferia_TextBox_Codigo.Text = P_Base_Campo_1;
                                Exferia_TextBox_Nombre.Exferia_TextBox_Foco();
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                Exferia_TextBox_Nombre.Text = P_Base_Campo_2;
                                Exferia_TextBox_Codigo.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            Exferia_TextBox_Codigo.Exferia_TextBox_Foco();
                        }


                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;
                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_Tecnico.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_Tecnico.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_Tecnico) + "/" + nameof(P_Tecnico_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }

        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_Tecnico.Visible)
            {
                Exferia_Paginador_Tecnico.Visible = _bol_Activar;
            }

            if (ex_btn_P_Tecnico_Borrar.Enabled)
            {
                ex_btn_P_Tecnico_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Procedimientos heredados de la Clase P_Base
        //Se utiliza para actualizar los listados dentro de la pantalla, sin tener que guardar
        public override void P_Base_ActualizarRegistro_ConObjeto(object _obj, G_ENUM_TIPOACCION _enum_TipoAccion)
        {
            try
            {
                if (_obj != null)
                {
                    P_Base_SeModificoDatosPantalla = true;

                    //Poner como que se modifico algo
                    P_Base_SeModificoDatosPantalla = true;
                }
            }
            catch (Exception ex)
            {
                Mensajes.MostrarMensaje(ex.Message);
            }
        }
        #endregion

        #region Botones Grabar,Borrar,BuscarCodigoSiguiente
        private void ex_btn_P_Tecnico_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (//Añadir
                 (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                 //Modificar
                 (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(true);
            }
        }

        private void ex_btn_P_Tecnico_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }

        private void ex_btn_P_Tecnico_BuscarCodigoSiguiente_Click(object sender, EventArgs e)
        {
            BuscarCodigoSiguiente();
        }
        private void BuscarCodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = g_obj_Controladora.Buscar_CodigoSiguiente();
            if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false && mdl_INTERNO_ValorDevuelto_Modelo.Mensaje.Trim().Length > 0)
            {
                Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo.Mensaje);
            }
            else
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }

        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Tecnico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Tecnico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Tecnico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Tecnico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_Tecnico.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Tecnico.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifica algo

        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }


        #endregion


    }
}
